angular.module('beamng.apps')
.directive('busDispctrl', ['$sce', function ($sce) {
  return {
    templateUrl:  '/ui/modules/apps/BusDispCtrl/app.html',
    replace: true,
    restrict: 'EA',
    require: '^bngApp',
    link: function ($scope, element, attrs, ctrl) {
 
      const settingspath = '/settings/BusDispCtrl/settings.json';
      $scope.lastsettingspath = '/settings/BusDispCtrl/lastsettings.json';
      const minipath = '/settings/BusDispCtrl/minimize.json';
		$scope.saveid = [0];
		$scope.rowcolour = ["#506070"];
		for (i = 1; i < 20; i++) {
			$scope.saveid.push(i);
			if (i % 2 == 1) {
				$scope.rowcolour.push("#203040");
			} else {
				$scope.rowcolour.push("#506070");
			}
		};
		var newSettings = [{
			saveno: "1",
			savedest: "Destinaton 1",
			savecolour: "#B40404"
		},{
			saveno: "2",
			savedest: "Destinaton 2",
			savecolour: "#B43104"
		},{
			saveno: "3",
			savedest: "Destinaton 3",
			savecolour: "#B45F04"
		},{
			saveno: "4",
			savedest: "Destinaton 4",
			savecolour: "#B18904"
		},{
			saveno: "5",
			savedest: "Destinaton 5",
			savecolour: "#AEB404"
		},{
			saveno: "6",
			savedest: "Destinaton 6",
			savecolour: "#86B404"
		},{
			saveno: "7",
			savedest: "Destinaton 7",
			savecolour: "#5FB404"
		},{
			saveno: "8",
			savedest: "Destinaton 8",
			savecolour: "#31B404"
		},{
			saveno: "9",
			savedest: "Destinaton 9",
			savecolour: "#04B404"
		},{
			saveno: "10",
			savedest: "Destinaton 10",
			savecolour: "#04B431"
		},{
			saveno: "11",
			savedest: "Destinaton 11",
			savecolour: "#04B45F"
		},{
			saveno: "12",
			savedest: "Destinaton 12",
			savecolour: "#04B486"
		},{
			saveno: "13",
			savedest: "Destinaton 13",
			savecolour: "#04B4AE"
		},{
			saveno: "14",
			savedest: "Destinaton 14",
			savecolour: "#0489B1"
		},{
			saveno: "15",
			savedest: "Destinaton 15",
			savecolour: "#045FB4"
		},{
			saveno: "16",
			savedest: "Destinaton 16",
			savecolour: "#0431B4"
		},{
			saveno: "17",
			savedest: "Destinaton 17",
			savecolour: "#0404B4"
		},{
			saveno: "18",
			savedest: "Destinaton 18",
			savecolour: "#3104B4"
		},{
			saveno: "19",
			savedest: "Destinaton 19",
			savecolour: "#5F04B4"
		},{
			saveno: "20",
			savedest: "Destinaton 20",
			savecolour: "#8904B1"
		}];
		$scope.appSettings = newSettings;
		var newlastSettings = {
			setrouteno: "",
			setdest: "",
			setroutecol: "#000000"
		};
		$scope.setdisp = newlastSettings;
		
      ctrl.getSettings = function (settings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(settingspath) + ')', (settings) => {
		if (settings == null) {return;}
		for (let i = 0; i < 20; i++) {
			  $scope.appSettings[i].saveno = settings[i].saveno;
			  $scope.appSettings[i].savedest = settings[i].savedest;
			  $scope.appSettings[i].savecolour = settings[i].savecolour;
		}
		});
      };
      ctrl.getlastSettings = function (lastsettings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ')', (lastsettings) => {
			if (lastsettings == null) {return;}
			  $scope.setdisp.setrouteno = lastsettings.setrouteno;
			  $scope.setdisp.setdest = lastsettings.setdest;
			  $scope.setdisp.setroutecol = lastsettings.setroutecol;
		});
      };

      ctrl.saveSettings = function (settings) {
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(settingspath) + ', ' + bngApi.serializeToLua(settings) + ', ' + bngApi.serializeToLua(true) + ')');
      };
	  
      ctrl.savemini = function (mini) {
		var savemn = [{
			minimize: mini
		}];
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(minipath) + ', ' + bngApi.serializeToLua(savemn) + ', ' + bngApi.serializeToLua(true) + ')');
      };
	  
		  $scope.toggleAll = function() {
			$scope.visible = !$scope.visible;
			if($scope.visible == false) {
			  $scope.appStyle = {appWidth: '160px', appHeight: '16px', appShow: 'hidden', miniWidth: '160px'};
			  $scope.cornerChar = '[Expand] Bus Display Controller';
			} else {
			  $scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '16px'};
			  $scope.cornerChar = '[Minimize]';
			}
			ctrl.savemini(!$scope.visible);
		  };
		  
      ctrl.getmini = function (minimize) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(minipath) + ')', (minimize) => {
			if (minimize == null) {return;}
			if(minimize[0].minimize == true) {
				$scope.toggleAll();
			}
		});
      };
	  
      element.ready(function () {
		  var loadsettings = null;
		  var loadlastsettings = null;
		  var loadmini = null;
        ctrl.getSettings(loadsettings);
            if(loadsettings != null) {$scope.appSettings = loadsettings};
        ctrl.getlastSettings(loadlastsettings);
            if(loadlastsettings != null) {$scope.setdisp = loadlastsettings};
        ctrl.getmini(loadmini);
            if(loadmini == null) {ctrl.savemini(false);};
      });
	  
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
			
		  $scope.savesetting = function () {
			  $scope.appSettings[$scope.selectedId].saveno = $scope.cusrouteno;
			  $scope.appSettings[$scope.selectedId].savedest = $scope.cusdest;
			  $scope.appSettings[$scope.selectedId].savecolour = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			ctrl.saveSettings($scope.appSettings);
		  };
		  
    },
    controller: function ($scope, $element, $attrs) {
		$scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '16px'};
		$scope.visible = true;
		$scope.disabled = true;
		$scope.cornerChar = '[Minimize]';
		$scope.cusrouteno = ""
		$scope.cusdest = ""
		$scope.selectedId = "0"
		  this.randomcolour = function() {
			$scope.cuscolor = {
			  red: Math.floor(Math.random() * 255),
			  green: Math.floor(Math.random() * 255),
			  blue: Math.floor(Math.random() * 255)
			};
		  };
		  this.randomcolour();
		  this.setcolour = function(r,g,b) {
			$scope.cuscolor = {
			  red: r,
			  green: g,
			  blue: b
			};
		  };
		  this.addicon = function(icon) {
			  if ($scope.cusroutenoChecked) {
				  $scope.cusrouteno += icon
			  }
			  if ($scope.cusdestChecked) {
				  $scope.cusdest += icon
			  }
		  };
		  this.savelastSettings = function (lastsettings) {
			bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ', ' + bngApi.serializeToLua(lastsettings) + ', ' + bngApi.serializeToLua(true) + ')');
		  };
		  this.setingameroute = function() {
			var cmd = `controller.onGameplayEvent("bus_onRouteChange", {direction="`+$scope.setdisp.setdest+`", routeID="`+$scope.setdisp.setrouteno+`", routeColor="`+$scope.setdisp.setroutecol+`"})`;
			bngApi.activeObjectLua(cmd);
			this.savelastSettings($scope.setdisp);
		  };
		  this.setroute = function(routeno,dest,colour) {
			$scope.setdisp.setrouteno = routeno;
			$scope.setdisp.setdest = dest;
			$scope.setdisp.setroutecol = colour;
			this.setingameroute();
		  };
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
		  this.setcusdisp = function() {
			$scope.setdisp.setrouteno = $scope.cusrouteno;
			$scope.setdisp.setdest = $scope.cusdest;
			$scope.setdisp.setroutecol = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			this.setingameroute();
		  };
		  function hexToRgb(hex) {
			var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
			return result ? {
				r: parseInt(result[1], 16),
				g: parseInt(result[2], 16),
				b: parseInt(result[3], 16)
			} : null;
			}
		  this.loadcusdisp = function() {
			$scope.cusrouteno = $scope.setdisp.setrouteno;
			$scope.cusdest = $scope.setdisp.setdest;
			$scope.cuscolor = {
			  red: hexToRgb($scope.setdisp.setroutecol).r,
			  green: hexToRgb($scope.setdisp.setroutecol).g,
			  blue: hexToRgb($scope.setdisp.setroutecol).b
			};
		  };
		  this.loadsetting = function () {
			  $scope.cusrouteno = $scope.appSettings[$scope.selectedId].saveno;
			  $scope.cusdest = $scope.appSettings[$scope.selectedId].savedest;
				$scope.cuscolor = {
				  red: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).r,
				  green: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).g,
				  blue: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).b
				};
				this.setcusdisp();
		  };
	},
    controllerAs: 'ctrl'
  };
}])